/***************************************************************************
 *   Copyright (C) 2004 by Work@                                           *
 *   jstubbs@work-at.co.jp                                                 *
 *                                                                         *
 *   This program may be distributed under the terms of the Q Public       *
 *   License as defined by Trolltech AS of Norway and appearing in the     *
 *   file LICENSE.QPL included in the packaging of this file.              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
 ***************************************************************************/

#ifndef __ADDER_H__
#define __ADDER_H__

#include <qobject.h>
#include <qstringlist.h>
#include <qprogressdialog.h>

#include "datatypes.h"
#include "cache.h"

class Adder
	: public QObject
{
	Q_OBJECT
	
	signals:
		void validSite(Site);
		void invalidUrl(QString);
	
	protected slots:
		void checkValid(QString, ItemList);
		void invalid(QString);
		void progressChange(QString, int);
		void modifyUrl(QString, QString);
	
	public:
		Adder(Cache*, bool, QWidget* parent = 0, const char* name = 0);
		void add(QString);
	
	private:
		void checkNext();
		
		QStringList adding;
		Cache* cache;
		QProgressDialog* progress;
		bool display;
};

#endif
