/***************************************************************************
 *   Copyright (C) 2004 by Work@                                           *
 *   jstubbs@work-at.co.jp                                                 *
 *                                                                         *
 *   This program may be distributed under the terms of the Q Public       *
 *   License as defined by Trolltech AS of Norway and appearing in the     *
 *   file LICENSE.QPL included in the packaging of this file.              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
 ***************************************************************************/

#include <qapplication.h>
#include <qtranslator.h>
#include <qtextcodec.h>
#include <qstring.h>

#include "mainwindow.h"
#include "paths.h"

QFile *logfile = 0;
QtMsgHandler prevfunc;
bool logerrors = true;

void myMessageOutput(QtMsgType type, const char *msg)
{
	if (!logerrors)
		return;

	QTextStream logstrm(logfile);

	if (logfile != 0) {
		logstrm << msg << "\n";
		logfile->flush();
	} else {
		prevfunc(type, msg);
	}
}


int main(int argc, char *argv[])
{
	prevfunc = qInstallMsgHandler(myMessageOutput);
	QApplication qApp(argc, argv);

	logerrors = false;
	for (int i = 0; i < argc; i++) {
		if (QCString(argv[i]) == "-d" || QCString(argv[i]) == "--debug")
			logerrors = true;
	}
	
	if (logerrors) {
		logfile = new QFile("debug.txt");
		if (!logfile->open(IO_WriteOnly)) {
			delete logfile;
			logfile = 0;
		}
	}
	
	QTranslator qt(0);
	QTranslator rt(0);
	qt.load(QString("qt_") + QTextCodec::locale(), ".");
	rt.load(QTextCodec::locale(), SHARED);
	qApp.installTranslator(&qt);
	qApp.installTranslator(&rt);
	
	MainWindow mw;
	qApp.setMainWidget(&mw);
	mw.show();
	return qApp.exec();
	if (logfile != 0) {
		logfile->close();
	}
}
